esup-blank-web-jsf-mixed/src/main/java/org/esupportail/blank/web/controllers/ExceptionController.java
/**
 * ESUP-Portail Blank Application - Copyright (c) 2010 ESUP-Portail consortium.
 */
package org.esupportail.blank.web.controllers;

import java.util.Map;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.portlet.PortletContext;
import javax.portlet.PortletRequest;
import javax.servlet.http.HttpSession;

import org.esupportail.commons.services.logging.Logger;
import org.esupportail.commons.services.logging.LoggerImpl;
import org.apache.myfaces.trinidad.util.ExternalContextUtils;
import org.esupportail.commons.exceptions.ConfigException;
import org.esupportail.commons.services.exceptionHandling.ExceptionUtils;
import org.esupportail.commons.utils.BeanUtils;
import org.esupportail.commons.utils.ContextUtils;
import org.esupportail.commons.web.controllers.Resettable;

/**
 * @author Yves Deschamps (Universite de Lille 1) - 2010
 * 
 */
public class ExceptionController extends
		org.esupportail.commons.web.controllers.ExceptionController {

	/**
	 * For Serialize.
	 */
	private static final long serialVersionUID = -8358372071814470805L;
	/**
	 * For Logging.
	 */
	private final Logger logger = new LoggerImpl(getClass());

	/**
	 * True if we are in portlet mode.
	 */
	private boolean portletMode;

	/**
	 * Constructors.
	 */
	public ExceptionController() {
		super();
	}

	/**
	 * @return true if portlet mode.
	 */
	private boolean isPortletMode() {
		if (logger.isDebugEnabled()) {
			logger.debug("Mode detected in Application");
		}
		FacesContext fc = FacesContext.getCurrentInstance();
		portletMode = ExternalContextUtils.isPortlet(fc.getExternalContext());
		if (logger.isDebugEnabled()) {
			if (portletMode) {
				logger.debug("Portlet mode detected");
			} else {
				logger.debug("Servlet mode detected");
			}
		}
		return portletMode;
	}

	@Override
	public String restart() {
		Map<String, Object> resettables = BeanUtils
				.getBeansOfClass(Resettable.class);
		for (String name : resettables.keySet()) {
			if (logger.isDebugEnabled()) {
				logger.debug("trying to reset bean [" + name + "]...");
			}
			Object bean = resettables.get(name);
			if (bean == null) {
				throw new ConfigException("bean [" + name + "] is null, "
						+ "application can not be restarted.");
			}
			if (!(bean instanceof Resettable)) {
				throw new ConfigException("bean [" + name
						+ "] does not implement Resettable, "
						+ "application can not be restarted.");
			}
			((Resettable) bean).reset();
			if (logger.isDebugEnabled()) {
				logger.debug("bean [" + name + "] was reset.");
			}
		}
		if (!isPortletMode()) {
			// it is always this case !
			ExceptionUtils.unmarkExceptionCaught();
			((HttpSession) FacesContext.getCurrentInstance()
					.getExternalContext().getSession(false)).invalidate();
		}
		return "applicationRestarted";
	}

	/**
	 * @return true if an exception have been detected.
	 */
	public boolean isException() {
		if (isPortletMode()) {
			FacesContext facesContext = FacesContext.getCurrentInstance();
			ExternalContext externalContext = facesContext.getExternalContext();
			PortletRequest request = (PortletRequest) externalContext
					.getRequest();
			ContextUtils.bindRequestAndContext(request,
					(PortletContext) externalContext.getContext());
		}
		return ExceptionUtils.getMarkedExceptionService() != null;
	}

}

esup-blank-web-jsf-mixed/src/main/java/org/esupportail/blank/web/controllers/PreferencesController.java
/**
 * ESUP-Portail Blank Application - Copyright (c) 2010 ESUP-Portail consortium.
 */
package org.esupportail.blank.web.controllers;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;

import org.esupportail.commons.services.i18n.I18nUtils;

/**
 * @author Yves Deschamps (Universite de Lille 1) - 2010
 * 
 */
public class PreferencesController extends AbstractContextAwareController {

	/**
	 * For Serialize.
	 */
	private static final long serialVersionUID = -4133220816313990369L;

	/**
	 * An items list for locals.
	 */
	private List<SelectItem> localeItems;

	/**
	 * An items list for accessibility.
	 */
	private List<SelectItem> accessibilityModeItems;

	/**
	 * Constructor.
	 */
	public PreferencesController() {
		super();
	}

	/**
	 * @return the localeItems
	 */
	public List<SelectItem> getLocaleItems() {
		if (localeItems == null) {
			localeItems = new ArrayList<SelectItem>();
			Iterator<Locale> iter = FacesContext.getCurrentInstance()
					.getApplication().getSupportedLocales();
			while (iter.hasNext()) {
				Locale locale = iter.next();
				StringBuffer buf = new StringBuffer(
						locale.getDisplayLanguage(locale));
				localeItems.add(new SelectItem(locale, buf.toString()));
			}
		}
		return localeItems;
	}


	/**
	 * @return the accessibilityModeItems
	 */
	public List<SelectItem> getAccessibilityModeItems() {
		accessibilityModeItems = new ArrayList<SelectItem>();
		accessibilityModeItems.add(new SelectItem("default", I18nUtils
				.createI18nService().getString(
						"PREFERENCES.ACCESSIBILITY.DEFAULT")));
		accessibilityModeItems.add(new SelectItem("inaccessible", I18nUtils
				.createI18nService().getString(
						"PREFERENCES.ACCESSIBILITY.INACCESSIBLE")));
		accessibilityModeItems.add(new SelectItem("screenReader", I18nUtils
				.createI18nService().getString(
						"PREFERENCES.ACCESSIBILITY.SCREENREADER")));
		return accessibilityModeItems;
	}
	
	@Override
	public void reset() {
		super.reset();
		accessibilityModeItems = null;
		localeItems = null;
	}
	
}

esup-blank-web-jsf-mixed/src/main/java/org/esupportail/blank/web/controllers/SessionController.java
/**
 * ESUP-Portail Blank Application - Copyright (c) 2010 ESUP-Portail consortium.
 */
package org.esupportail.blank.web.controllers;

import java.io.IOException;
import java.util.Locale;

import javax.faces.component.UIParameter;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.servlet.http.HttpServletRequest;

import org.esupportail.commons.exceptions.UserNotFoundException;
import org.esupportail.commons.services.i18n.I18nUtils;
import org.esupportail.commons.services.logging.Logger;
import org.esupportail.commons.services.logging.LoggerImpl;
import org.apache.myfaces.trinidad.util.ExternalContextUtils;
import org.esupportail.blank.domain.beans.User;
import org.esupportail.blank.services.auth.Authenticator;
import org.esupportail.commons.utils.Assert;
import org.esupportail.commons.utils.strings.StringUtils;
import org.esupportail.commons.web.controllers.ExceptionController;

/**
 * @author Yves Deschamps (Universite de Lille 1) - 2010
 * 
 */
public class SessionController extends AbstractDomainAwareBean {

	/**
	 * For Serialize.
	 */
	private static final long serialVersionUID = 6725001881639400299L;

	/**
	 * For Logging.
	 */
	private final Logger logger = new LoggerImpl(getClass());

	/**
	 * The exception controller.
	 */
	private ExceptionController exceptionController;

	/**
	 * The application version.
	 */
	private String version;

	/**
	 * The application site.
	 */
	private String site;

	/**
	 * The current action from menu.
	 */
	private String action;

	/**
	 * The from form current action.
	 */
	private String fromAction;

	/**
	 * The authenticator.
	 */
	private Authenticator authenticator;

	/**
	 * The detected mode (desktop or mobile).
	 */
	private boolean modeDetected;

	/**
	 * True if we are in portlet mode.
	 */
	private boolean portletMode;

	/**
	 * The accessibility mode.
	 */
	private String accessibilityMode = "default";

	/**
	 * The CAS logout URL.
	 */
	private String casLogoutUrl;

	/**
	 * The show exception details state.
	 */
	private boolean showExceptionDetails;

	/**
	 * The current User.
	 */
	private User currentUser;

	/**
	 * Constructor.
	 */
	public SessionController() {
		super();
	}

	@Override
	public void afterPropertiesSet() {
		Assert.notNull(this.exceptionController,
				"property exceptionController of class "
						+ this.getClass().getName() + " can not be null");
		Assert.notNull(this.authenticator, "property authenticator of class "
				+ this.getClass().getName() + " can not be null");
		Assert.notNull(this.version, "property version of class "
				+ this.getClass().getName() + " can not be null");
		Assert.notNull(this.site, "property site of class "
				+ this.getClass().getName() + " can not be null");
		Assert.notNull(this.casLogoutUrl, "property casLogoutUrl of class "
				+ this.getClass().getName() + " can not be null");
	}

	/**
	 * 
	 * @return the version
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * @param version
	 *            the version to set
	 */
	public void setVersion(String version) {
		this.version = version;
	}

	/**
	 * @return the site
	 */
	public String getSite() {
		return site;
	}

	/**
	 * @param site
	 *            the site to set
	 */
	public void setSite(String site) {
		this.site = site;
	}

	/**
	 * @return the action
	 */
	public String getAction() {
		return action;
	}

	/**
	 * @param action
	 *            the action to set
	 */
	public void setAction(String action) {
		this.action = action;
	}

	@Override
	public User getCurrentUser() {
		if (isPortletMode()) {
			FacesContext fc = FacesContext.getCurrentInstance();
			String uid = fc.getExternalContext().getRemoteUser();
			if (currentUser != null && currentUser.getLogin().equals(uid)) {
				return currentUser;
			}
			try {
				currentUser = getDomainService().getUser(uid);
			} catch (UserNotFoundException e) {
				currentUser = new User();
				currentUser.setLogin(uid);
				currentUser.setDisplayName(I18nUtils.createI18nService()
						.getString(e.getMessage()));
				currentUser.setAdmin(false);
			}
			return currentUser;
		}
		User authUser;
		try {
			authUser = authenticator.getUser();
			if (authUser != null) {
				if (currentUser != null
						&& currentUser.getLogin().equals(authUser.getLogin())) {
					return currentUser;
				}
				// for updating
				String uid = authUser.getLogin();
				try {
					currentUser = getDomainService().getUser(uid);
				} catch (UserNotFoundException e) {
					currentUser = new User();
					currentUser.setLogin(uid);
					currentUser.setDisplayName(I18nUtils.createI18nService()
							.getString(e.getMessage()));
					currentUser.setAdmin(false);
				}
				return currentUser;
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	@Override
	public void reset() {
		super.reset();
		action = null;
		fromAction = null;
		currentUser = null;
	}

	/**
	 * @return the fromAction
	 */
	public String getFromAction() {
		return fromAction;
	}

	/**
	 * @param fromAction
	 *            the fromAction to set
	 */
	public void setFromAction(String fromAction) {
		this.fromAction = fromAction;
	}

	/**
	 * @return true if portlet mode.
	 */
	public boolean isPortletMode() {
		if (!modeDetected) {
			modeDetected = true;
			if (logger.isDebugEnabled()) {
				logger.debug("Mode detected in Application");
			}
			FacesContext fc = FacesContext.getCurrentInstance();
			portletMode = ExternalContextUtils.isPortlet(fc
					.getExternalContext());
			if (logger.isDebugEnabled()) {
				if (portletMode) {
					logger.debug("Portlet mode detected");
				} else {
					logger.debug("Servlet mode detected");
				}
			}
		}
		return portletMode;
	}

	/**
	 * @return true if login button is enable.
	 * @throws Exception
	 */
	public boolean isLoginEnable() throws Exception {
		if (isPortletMode()) {
			return false;
		}
		return (getCurrentUser() == null);
	}

	/**
	 * @return true if login button is enable.
	 * @throws Exception
	 */
	public boolean isLogoutEnable() throws Exception {
		if (isPortletMode()) {
			return false;
		}
		return (getCurrentUser() != null);
	}

	/**
	 * @return nothing and make logout.
	 */
	public String logoutAction() {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		ExternalContext externalContext = facesContext.getExternalContext();
		HttpServletRequest request = (HttpServletRequest) externalContext
				.getRequest();
		String preReturnUrl = request.getRequestURL().toString()
				.replaceFirst("/stylesheets/[^/]*$", "");
		int index = preReturnUrl.lastIndexOf("/");
		String returnUrl = preReturnUrl.substring(0, index + 1).concat(
				"welcome.xhtml");
		String forwardUrl;
		forwardUrl = String.format(casLogoutUrl,
				StringUtils.utf8UrlEncode(returnUrl));
		request.getSession().invalidate();
		request.getSession(true);
		try {
			externalContext.redirect(forwardUrl);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		facesContext.responseComplete();
		// Il convient de desactiver les elements d'identification et de
		// navigation
		action = "welcome";
		return null;
	}

	/**
	 * @param casLogoutUrl
	 *            the casLogoutUrl to set
	 */
	public void setCasLogoutUrl(String casLogoutUrl) {
		this.casLogoutUrl = casLogoutUrl;
	}

	/**
	 * @param authenticator
	 *            the authenticator to set
	 */
	public void setAuthenticator(Authenticator authenticator) {
		this.authenticator = authenticator;
	}

	/**
	 * @param locale
	 *            the locale to set
	 */
	public void setLocale(Locale locale) {
		FacesContext context = FacesContext.getCurrentInstance();
		if (context != null) {
			context.getViewRoot().setLocale(locale);
		}
	}

	@Override
	public Locale getLocale() {
		Locale locale = new Locale("fr");
		FacesContext context = FacesContext.getCurrentInstance();
		if (context != null) {
			locale = context.getViewRoot().getLocale();
		}
		return locale;
	}

	/**
	 * @return the accessibility mode of the current user or default if not
	 *         authenticated.
	 */
	public String getAccessibilityMode() {
		return accessibilityMode;
	}

	/**
	 * @param accessibilityMode
	 *            The accessibilityMode to set
	 */
	public void setAccessibilityMode(String accessibilityMode) {
		this.accessibilityMode = accessibilityMode;
	}

	/**
	 * @param exceptionController
	 */
	public void setExceptionController(ExceptionController exceptionController) {
		this.exceptionController = exceptionController;
	}

	/**
	 * @return the show exception details state.
	 */
	public boolean isShowExceptionDetails() {
		return showExceptionDetails;
	}

	/**
	 * @return navigation.
	 */
	public String showExceptionDetailsAction() {
		this.showExceptionDetails = true;
		return null;
	}

	/**
	 * @return navigation.
	 */
	public String hideExceptionDetailsAction() {
		this.showExceptionDetails = false;
		return null;
	}

	/**
	 * @return an Url (with the good host, port and context...).
	 */
	public String getServletUrl() {
		FacesContext facesContext = FacesContext.getCurrentInstance();
		return facesContext.getExternalContext().getRequestContextPath()
				+ "/stylesheets/home.xhtml";
	}

	/**
	 * @return display accessibility mode.
	 */
	public String getDisplayAccessibilityMode() {
		if (accessibilityMode.equals("default"))
			return I18nUtils.createI18nService().getString(
					"PREFERENCES.ACCESSIBILITY.DEFAULT");
		if (accessibilityMode.equals("inaccessible"))

esup-blank-web-jsf-mixed/src/main/webapp/stylesheets/desktop/about.xhtml
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:tr="http://myfaces.apache.org/trinidad" template="template.xhtml">
	<ui:define name="content">
		<tr:document title="#{msgs['BLANK.TEXT']}">
			<tr:spacer height="20px" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['BLANK.TEXT']}&lt;/b&gt;, Version: #{sessionController.version}" />
			<tr:spacer height="20px" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['ABOUT.TEXT.SUMMARY']}&lt;/b&gt;: #{msgs['ABOUT.TEXT.SUMMARY.CONTENT']}" />
			<tr:spacer height="20px" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['ABOUT.TEXT.AUTHORS']}&lt;/b&gt;:" />
			<tr:panelList rows="1">
				<tr:outputFormatted styleUsage="instruction"
					value="#{msgs['ABOUT.AUTHOR.NAME']}" />
			</tr:panelList>
			<tr:spacer height="20px" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['ABOUT.TEXT.COPYRIGHT']}&lt;/b&gt;" />
			<tr:spacer height="20px" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['ABOUT.TEXT.LICENCE']}&lt;/b&gt;: " />
			<tr:goLink text="#{msgs['ABOUT.TEXT.LICENCE.CONTENT']}"
				destination="#{msgs['ABOUT.TEXT.LICENCE.CONTENT.LINK']}" />
			<tr:spacer height="20px" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['ABOUT.TEXT.OTHERS']}&lt;/b&gt;: #{msgs['ABOUT.TEXT.OTHERS.CONTENT']}" />
		</tr:document>
	</ui:define>
</ui:composition>

esup-blank-web-jsf-mixed/src/main/webapp/stylesheets/desktop/help.xhtml
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:tr="http://myfaces.apache.org/trinidad" template="template.xhtml">
	<ui:define name="content">
    <tr:document title="#{msgs['BLANK.TEXT']}">
        <tr:form>
            <tr:spacer height="20px" />
            <tr:outputFormatted styleUsage="instruction" value="&lt;b&gt;#{msgs['HELP.TEXT']}&lt;/b&gt;" />
            <tr:spacer height="20px" />
            <tr:outputFormatted styleUsage="instruction" value="&lt;b&gt;#{msgs['HELP.TEXT.SUMMARY']}&lt;/b&gt;" />
        </tr:form>
    </tr:document>
	</ui:define>
</ui:composition>

esup-blank-web-jsf-mixed/src/main/webapp/stylesheets/desktop/menu.xhtml
<tr:form xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:tr="http://myfaces.apache.org/trinidad" id="navigation">
	<tr:navigationPane hint="bar" shortDesc="#{msgs['MENU.SHORTDESC']}">
		<tr:commandNavigationItem text="#{msgs['WELCOME.TEXT']}"
			action="welcome"
			disabled="#{empty sessionController.action
            or sessionController.action=='welcome'}">
			<f:setPropertyActionListener value="welcome"
				target="#{sessionController.action}" />
		</tr:commandNavigationItem>
		<tr:commandNavigationItem text="#{msgs['PREFERENCES.TEXT']}"
			action="preferences"
			disabled="#{not empty sessionController.action
            and sessionController.action=='preferences'}">
			<f:setPropertyActionListener value="preferences"
				target="#{sessionController.action}" />
		</tr:commandNavigationItem>
		<tr:commandNavigationItem text="#{msgs['ABOUT.TEXT']}" action="about"
			disabled="#{not empty sessionController.action
            and sessionController.action=='about'}">
			<f:setPropertyActionListener value="about"
				target="#{sessionController.action}" />
		</tr:commandNavigationItem>
		<tr:commandNavigationItem text="#{msgs['HELP.TEXT']}" action="help"
			disabled="#{not empty sessionController.action
            and sessionController.action=='help'}">
			<f:setPropertyActionListener value="help"
				target="#{sessionController.action}" />
		</tr:commandNavigationItem>
		<tr:commandNavigationItem text="#{msgs['LOGIN.TEXT']}"
			destination="/stylesheets/protected/login.xhtml"
			rendered="#{sessionController.loginEnable}" />
		<tr:commandNavigationItem text="#{msgs['LOGOUT.TEXT']}"
			action="#{sessionController.logoutAction}" immediate="true"
			rendered="#{sessionController.logoutEnable}" />
		<tr:commandNavigationItem text="#{msgs['MOBILE.TEXT']}"
			action="mobileWelcome" immediate="true"
			rendered="#{not sessionController.portletMode}" />
		<tr:commandNavigationItem text=""
			immediate="true" rendered="#{sessionController.portletMode}">
			<h:outputLink value="#{sessionController.servletUrl}" target="_popup"
				title="#{msgs['SERVLET.TEXT']}">
				<tr:outputText value="#{msgs['SERVLET.TEXT']}"
					styleClass="centerMessageLink" />
			</h:outputLink>
		</tr:commandNavigationItem>
	</tr:navigationPane>
</tr:form>

esup-blank-web-jsf-mixed/src/main/webapp/stylesheets/desktop/preferences.xhtml
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:tr="http://myfaces.apache.org/trinidad" template="template.xhtml">
	<ui:define name="content">
		<tr:form>
			<tr:panelFormLayout rows="3" maxColumns="1" labelWidth="140">
				<tr:spacer height="20px" />
				<tr:selectOneChoice label="#{msgs['PREFERENCES.LANGUAGE.LABEL']}: "
					value="#{sessionController.locale}">
					<f:selectItems value="#{preferencesController.localeItems}" />
				</tr:selectOneChoice>
				<tr:spacer height="20px" />
				<tr:selectOneChoice
					label="#{msgs['PREFERENCES.ACCESSIBILITY.LABEL']}: "
					value="#{sessionController.accessibilityMode}">
					<f:selectItems
						value="#{preferencesController.accessibilityModeItems}" />
				</tr:selectOneChoice>
			</tr:panelFormLayout>
			<tr:spacer height="20px" />
			<tr:commandButton text="#{msgs['SUBMIT.TEXT']} "
				id="changePreferences" action="preferences"
				icon="/media/images/accept.png" />
		</tr:form>
		<tr:outputDocument
			value="#{msgs['PREFERENCES.ACCESSIBILITY.SCREENREADER.TEXT']}"
			rendered="#{sessionController.accessibilityMode=='screenReader'}" />
	</ui:define>
</ui:composition>

esup-blank-web-jsf-mixed/src/main/webapp/stylesheets/desktop/template.xhtml
<f:view xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:tr="http://myfaces.apache.org/trinidad"
	locale="#{sessionController.locale}">
	<tr:document title="#{msgs['BLANK.TEXT']}">
	<!-- div class for portlet css -->
	<div class="trinidad12">
		<tr:group rendered="#{not exceptionController.exception}">
			<ui:include src="menu.xhtml" />
			<ui:insert name="content" />
		</tr:group>
		<tr:group rendered="#{exceptionController.exception}">
			<tr:form id="exceptionButtons">
			<tr:commandButton text="#{msgs['EXCEPTION.BUTTON.RESTART']}"
				id="restart" action="#{exceptionController.restart}" />
			</tr:form>
		</tr:group>
	</div>
	</tr:document>
</f:view>

esup-blank-web-jsf-mixed/src/main/webapp/stylesheets/desktop/template_exception.xhtml
<f:view xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:tr="http://myfaces.apache.org/trinidad"
	locale="#{sessionController.locale}">
	<tr:document title="#{msgs['BLANK.TEXT']}">
		<tr:outputFormatted styleUsage="instruction"
			value="&lt;b&gt;#{msgs['BLANK.TEXT']}. #{msgs['EXCEPTION.TITLE']}&lt;/b&gt;" />
		<ui:insert name="exceptionButtons" />
		<ui:insert name="exceptionDetailsPanel" />
	</tr:document>
</f:view>

esup-blank-web-jsf-mixed/src/main/webapp/stylesheets/desktop/welcome.xhtml
<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
	xmlns:h="http://java.sun.com/jsf/html"
	xmlns:f="http://java.sun.com/jsf/core"
	xmlns:tr="http://myfaces.apache.org/trinidad" template="template.xhtml">
	<ui:define name="content">
		<tr:group>
			<tr:spacer height="20px" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['USER.TEXT']}:&lt;/b&gt; #{sessionController.currentUser.displayName} - #{msgs['ADMIN.TRUE.TEXT']} - #{msgs['PREFERENCES.LANGUAGE.SHORT_LABEL']}#{sessionController.displayLanguage} - #{msgs['PREFERENCES.ACCESSIBILITY.SHORT_LABEL']}#{sessionControllerdisplayAccessibilityMode}"
				rendered="#{not empty sessionController.currentUser and sessionController.currentUser.admin}" />
			<tr:outputFormatted styleUsage="instruction"
				value="&lt;b&gt;#{msgs['USER.TEXT']}:&lt;/b&gt; #{sessionController.currentUser.displayName} - #{msgs['PREFERENCES.LANGUAGE.SHORT_LABEL']}#{sessionController.displayLanguage} - #{msgs['PREFERENCES.ACCESSIBILITY.SHORT_LABEL']}#{sessionController.displayAccessibilityMode}"
				rendered="#{not empty sessionController.currentUser and not sessionController.currentUser.admin}" />
		</tr:group>
		<tr:spacer height="20px" />
		<tr:outputFormatted styleUsage="instruction"
			value="&lt;b&gt;#{msgs['WELCOME.INTRO_1']}#{msgs['BLANK.TEXT']}#{msgs['WELCOME.INTRO_2']}#{sessionController.version}#{msgs['WELCOME.INTRO_3']}&lt;/b&gt;" />
	</ui:define>
</ui:composition>